// ModeView.cpp : implementation of the CModeView class
//

#include "stdafx.h"
#include "Mode.h"

#include "ModeDoc.h"
#include "ModeView.h"

#include "mainfrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CModeView

IMPLEMENT_DYNCREATE(CModeView, CScrollView)

BEGIN_MESSAGE_MAP(CModeView, CScrollView)
	//{{AFX_MSG_MAP(CModeView)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CModeView construction/destruction

CModeView::CModeView()
{
	// TODO: add construction code here

}

CModeView::~CModeView()
{
}

BOOL CModeView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CModeView drawing



void CModeView::OnDraw(CDC* pDC)
{
	CModeDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// desenha eixo
	mEixo ( pDC );

	// exibe pontos
	mExibe ( pDC );
}



void CModeView::OnInitialUpdate() 
{
	CScrollView::OnInitialUpdate();
	
	// definicoes da janela
	// tamanho da area de cliente
	RECT
		stTamCli;
	GetClientRect ( &stTamCli );
	m_nXCli = stTamCli.right;
	m_nYCli = stTamCli.bottom;
	// tamanho x e y do universo
	m_nTamU = 10000;
	// origem do sistema de coordenadas do objeto
	m_nXO = 100;
	m_nYO = m_nTamU / 2;

	// define como nao havendo nenhum ponto selecionado
	m_nPSel = -1;

	mConfigBarras ();

	// posiciona barras no meio do sistema de coordenadas
	ScrollToPosition ( CPoint ( m_nXO - m_nXCli / 2, m_nYO - m_nYCli / 2 ) );
}



/////////////////////////////////////////////////////////////////////////////
// CModeView diagnostics

#ifdef _DEBUG
void CModeView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CModeView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CModeDoc* CModeView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CModeDoc)));
	return (CModeDoc*)m_pDocument;
}
#endif //_DEBUG



/////////////////////////////////////////////////////////////////////////////
// FUNCOES USADAS PELA CLASSE

/* Desenha uma linha
**********************************************************/
void CModeView::mLinha ( int nX1, int nY1, int nX2, int nY2, CDC* pDC )
{
	pDC->MoveTo ( nX1, nY1 );
	pDC->LineTo ( nX2, nY2 );
}



/* Desenha o eixo do sistema de coordenadas do universo
**********************************************************/
void CModeView::mEixo ( CDC* pDC )
{
	// cria linha com estilo da linha do eixo
	CPen
		oLEixo,
		*poAnterior;
	COLORREF
		stCor = RGB ( 255, 0, 0 );
	oLEixo.CreatePen ( PS_SOLID, 1, stCor );
	poAnterior = pDC->SelectObject ( &oLEixo );
	
	// desenha eixos
	// desenha linha do eixo y
	mLinha ( m_nXO, 0, m_nXO, m_nTamU, pDC );
	// desenha linha do eixo x
	mLinha ( 0, m_nYO, m_nTamU, m_nYO, pDC );

	// retorna a linha de estilo anterior
	pDC->SelectObject ( poAnterior );
	oLEixo.DeleteObject ();
}



/* Retorna as coordenadas do mouse no universo.
Usa: m_nXM e m_nYM
**********************************************************/
void CModeView::mRetCoords ( int& nX, int& nY )
{
	// define posicao do canto superior esquerdo da janela no universo
	CPoint
		oPSc = GetScrollPosition ();
	int
		nXi = oPSc.x - m_nXO,
		nYi = oPSc.y - m_nYO;
	// define posicao do mouse no universo
	nX = nXi + m_nXM;
	nY = nYi + m_nYM;
}



/* Desenha uma marca que indica que o ponto foi selecionado
**********************************************************/
void CModeView::mMarca ( int nX, int nY, int nCor, CDC *pDC )
{
	for ( int ncY = nY - 4; ncY < nY + 4; ncY ++ )
		for ( int ncX = nX - 4; ncX < nX + 4; ncX ++ )
			pDC->SetPixel ( ncX + m_nXO, ncY + m_nYO, RGB ( 0, nCor, 0 ) );
}



/* Exibe pontos existentes no documento
**********************************************************/
void CModeView::mExibe ( CDC *pDC )
{
	// aponta documento
	CModeDoc
		*poDoc = GetDocument ();

	// verifica se exite algum ponto, se nao tiver sai
	if ( poDoc->m_adwX.GetSize () == 0 )
		return;

	// varre matrizes marcando pontos
	// define primeiro ponto
	int
		nX1 = poDoc->m_adwX [ 0 ],
		nY1 = poDoc->m_adwY [ 0 ],
		nX2,
		nY2;
	// marca primeiro ponto
	pDC->SetPixel ( nX1 + m_nXO, nY1 + m_nYO, RGB ( 0, 0, 0 ) );
	// desenha marca sobre ponto
	// verifica se o ponto foi selecionado
	if ( m_nPSel == 0 )
		mMarca ( nX1, nY1, 255, pDC );
	else
		if ( ( (CModeApp*) AfxGetApp () ) -> m_bMover ) 
			mMarca ( nX1, nY1, 0, pDC );
	// se tiver mais de um ponto
	if ( (UINT) poDoc->m_adwX.GetSize () > 1 )
		// varre matrizes
		for ( UINT ucP = 1; ucP < (UINT) poDoc->m_adwX.GetSize (); ucP ++ ) {

			// define proximo ponto
			nX2 = (int) poDoc->m_adwX [ ucP ];
			nY2 = (int) poDoc->m_adwY [ ucP ];
			// desenha marca sobre ponto
			// verifica se o ponto foi selecionado
			if ( m_nPSel == (int) ucP )
				mMarca ( nX2, nY2, 255, pDC );
			else
				if ( ( (CModeApp*) AfxGetApp () ) -> m_bMover ) 
					mMarca ( nX2, nY2, 0, pDC );
			// desenha linha
			mLinha ( nX1 + m_nXO, nY1 + m_nYO, nX2 + m_nXO, nY2 + m_nYO, pDC );
			// define ponto anterior
			nX1 = nX2;
			nY1 = nY2;
		}
}



/* Configura dimenssoes das barras de rolagem
**********************************************************/
void CModeView::mConfigBarras ()
{
	// tamanho da area de scroll (universo)
	CSize sizeTotal;
	sizeTotal.cx = sizeTotal.cy = m_nTamU;
	// quanto rola a cada pagina
	CSize sizePag;
	sizePag.cx = m_nXCli;
	sizePag.cy = m_nYCli;
	// quanto rola a cada clique nas setas
	CSize sizeUnid;
	sizeUnid.cx = 10;
	sizeUnid.cy = 10;
	// redefine barras
	SetScrollSizes(MM_TEXT, sizeTotal,sizePag, sizeUnid);
}



/////////////////////////////////////////////////////////////////////////////
// CModeView message handlers

void CModeView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// Aponta para janela principal (para ter acesso a barra de status onde estao 
	// coordenadas).
	CMainFrame
		*poMF = (CMainFrame*) AfxGetMainWnd();

	// define coordenadas do mouse na tela
	m_nXM = point.x;
	m_nYM = point.y;

	// altera barra de status para exibir coordenadas
	int
		nX,
		nY;
	mRetCoords ( nX, nY );
	char
		szXY [ 200 ];
	sprintf ( szXY, "x = %d,  y = %d", nX, nY );
	CString
		oszXY = szXY;
	CStatusBarCtrl
		&oStatusBar = poMF->m_wndStatusBar.GetStatusBarCtrl ();
	oStatusBar.SetText( oszXY, 1, 0 );
	
	CScrollView::OnMouseMove(nFlags, point);
}



void CModeView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// define coordenadas do mouse na tela
	m_nXM = point.x;
	m_nYM = point.y;
	// define coordenadas no universo
	int
		nX,
		nY;
	mRetCoords ( nX, nY );

	// verifica se foi clicado a esquerda (x < 0), se sim aborta
	if ( nX < 0 ) {
		AfxMessageBox ( IDS_POSITIVEX );
		CScrollView::OnLButtonDown(nFlags, point);
		return;
	}

	// aponta documento
	CModeDoc
		*poDoc = GetDocument ();

	// verifica em qual modo esta
	// se estah em modo inserir ponto entao insere
	if ( ( (CModeApp*) AfxGetApp () ) -> m_bMover == FALSE ) {
		// inclui um ponto nas matrizes de pontos
		// inclui ponto
		poDoc->m_adwX.Add ( (DWORD) nX );
		poDoc->m_adwY.Add ( (DWORD) nY );
	}
	else {
		// estao em modo de mover\inserir ponto

		// FASE 1: selecionar ponto
		// procura ponto proximo ao local clicado e guarda indice
		if ( m_nPSel == -1 ) {
			// varre matriz de pontos
			for ( int ncP = 0; ncP < poDoc->m_adwX.GetSize (); ncP ++ ) 
				// verifica se existe algum ponto proximo ao local clicado
				if ( (int) poDoc->m_adwX [ ncP ] < nX + 4 && (int) poDoc->m_adwX [ ncP ] > nX - 4 &&
					 (int) poDoc->m_adwY [ ncP ] < nY + 4 && (int) poDoc->m_adwY [ ncP ] > nY - 4 ) {
					m_nPSel = ncP;
					break;
				}
			// nao achou ponto
			if ( m_nPSel == -1 )
				AfxMessageBox ( IDS_SELECTPOINT );
		}
		else {
			// FASE 2: alterar coordenadas do ponto
			// altera coordenadas
			poDoc->m_adwX [ m_nPSel ] = nX;
			poDoc->m_adwY [ m_nPSel ] = nY;
		}
	}

	// define documento como alterado
	poDoc->SetModifiedFlag ( TRUE );

		// desenha pontos
	poDoc->UpdateAllViews ( NULL );

	CScrollView::OnLButtonDown(nFlags, point);
}



void CModeView::OnSize(UINT nType, int cx, int cy) 
{
	CScrollView::OnSize(nType, cx, cy);
	
	// atualiza tamanho da janela
	m_nXCli = cx;
	m_nYCli = cy;

	// configura barras de rolagem conforme tamanho da janela
	mConfigBarras ();
}
